package chuidiang.pruebas;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLayeredPane;
import javax.swing.WindowConstants;

public class PruebaJLayeredPane extends JLayeredPane
{

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        PruebaJLayeredPane p =new PruebaJLayeredPane();
        JFrame v = new JFrame();
        v.getContentPane().add(p);
        v.setSize(500,500);
        v.setVisible(true);
        v.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        p.updateUI();
    }

    Rejilla rejilla = new Rejilla();
    Dibujo dibujo = new Dibujo();
    public PruebaJLayeredPane()
    {
        add(rejilla,new Integer(10));
        add(dibujo,new Integer(20));
        addComponentListener(new ComponentListener()
        {
        
            public void componentHidden(ComponentEvent e)
            {
            }
        
            public void componentShown(ComponentEvent e)
            {
            }
        
            public void componentMoved(ComponentEvent e)
            {
            }
        
            public void componentResized(ComponentEvent e)
            {
                rejilla.setBounds(0,0,getWidth(),getHeight());
                dibujo.setBounds(0,0,getWidth(),getHeight());
            }
        
        });
    }
}

class Rejilla extends JComponent
{
    public void paint (Graphics g)
    {
        int ancho = getWidth();
        int alto = getHeight();
        for (int i=0;i<ancho;i=i+10)
        {
            g.drawLine(i,0,i,alto);
        }
        for (int i=0;i<alto;i=i+10)
        {
            g.drawLine(0,i,ancho,i);
        }
    }
}

class Dibujo extends JComponent
{
    public void paint (Graphics g)
    {
        g.setColor(Color.red);
        g.fill3DRect(10,10,30,30,true);
    }
}